<template>
  <div>
    <div style="width: 85%; height: 100%; margin: auto">
      <q-input v-model="search_bar.model.value" hint="Search node" class="search-bar">
        <template v-slot:append>
          <q-icon name="search" />
        </template>
      </q-input>
      <q-scroll-area
        :thumb-style="thumbStyle"
        :content-style="contentStyle"
        :content-active-style="contentActiveStyle"
        :bar-style="barStyle"
        style="height: 100%"
      >
        <span class="text-h6">Controllers</span>
        <div class="row">
          <rendered-node
            v-for="(node, index) in controller_nodes"
            :key="`controller${index}-${node.name}`"
            :node="node"
          />
        </div>
        <q-separator class="separator" inset size="1px" color="black" />
        <span class="text-h6">References</span>
        <div class="row">
          <rendered-node
            v-for="(node, index) in reference_nodes"
            :key="`reference${index}-${node.name}`"
            :node="node"
          />
        </div>
        <q-separator class="separator" inset size="1px" color="black" />
        <span class="text-h6">Testbed</span>
        <div class="row">
          <rendered-node v-for="(node, index) in testbed_nodes" :key="`testbed${index}-${node.name}`" :node="node" />
        </div>
      </q-scroll-area>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, computed } from 'vue';
import RenderedNode from './Node.vue';
import { Node } from 'src/models/workflow';
import { get_node_list } from 'components/task/workflow/nodes';
import { scrollBarStyle } from '../utils';

export default defineComponent({
  components: {
    RenderedNode,
  },
  setup() {
    const search_bar = {
      model: ref(''),
      filter: (input: string) => input.toLowerCase().includes(search_bar.model.value.toLowerCase()),
    };

    const nodes = {
      controller_nodes: computed(() =>
        get_node_list('controller').filter((node: Node) => search_bar.filter(node.name))
      ),
      reference_nodes: computed(() => get_node_list('reference').filter((node: Node) => search_bar.filter(node.name))),
      testbed_nodes: computed(() => get_node_list('testbed').filter((node: Node) => search_bar.filter(node.name))),
    };
    return {
      ...nodes,
      ...scrollBarStyle,
      search_bar,
    };
  },
});
</script>

<style lang="sass" scoped>
.search-bar
  width: 66%
  margin: 24px auto

.separator
  margin-top: 24px
  margin-bottom: 36px
</style>
